package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.taskcontrol.*;
import com.tmax.openframe.tdq.TDQ;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPINQR_InputDto;
import com.tmax.openframe.dto.OIVPINQR_OutputDto;
import com.tmax.openframe.variable.OIVPINQR_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINQR implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPINQR_VariableContainer container = new OIVPINQR_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0300_GO_MAIN = this::_0300_GO_MAIN;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_INFO = this::_5200_INFO;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0300_GO_MAIN);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_INFO);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPINQR_InputDto inputDto;
    @Getter
    @Setter
    OIVPINQR_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPINQR() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPINQR_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPINQR_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF1_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0300_GO_MAIN);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM03I(OIVPINQR_OIVPM03I.createDefaultValueInstance());
        container.setMSGO("DATA FOUND");
        run(_5200_INFO);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS ENQ RESOURCE('OIVPTDQR') LENGTH(8) END-EXEC");
        try {
            EnqOption option = EnqOption.builder().resource("OIVPTDQR")
                    .length(8).build();
            TaskControl.enq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS READQ TD QUEUE(TDQ01) INTO(PEOPLE-INFO-GET) LENGTH(DATALEN) END-EXEC");
        try {
            ReadqTDOption option = ReadqTDOption
                    .builder()
                    .queue(container.getTDQ01())
                    .into(OIVPINQR_PEOPLE_INFO_GET_To_OIVPINQR_PEOPLE_INFO_GET_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO_GET()))
                    .length((int) container.getDATALEN()).build();
            TDQ.read(option);
            container
                    .setPEOPLE_INFO_GET(OIVPINQR_PEOPLE_INFO_GET_To_OIVPINQR_PEOPLE_INFO_GET_DOMapper.INSTANCE
                            .toSource((OIVPINQR_PEOPLE_INFO_GET_DO) option
                                    .getInto()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setIDENO(String.valueOf(container.getPEOPLE_INFO_GET()
                .getWS_KEY()));
        container.setNAMEO(container.getPEOPLE_INFO_GET().getWS_NAME());
        container.setDEPTO(container.getPEOPLE_INFO_GET().getWS_DEPARTMENT());
        container.setPHONO(container.getPEOPLE_INFO_GET().getWS_PHONE());
        container.setEMALO(container.getPEOPLE_INFO_GET().getWS_EMAIL());
        container.setADDRO(container.getPEOPLE_INFO_GET().getWS_ADDRESS());
        // ("EXEC CICS DEQ RESOURCE('OIVPTDQR') LENGTH(8) END-EXEC");
        try {
            DeqOption option = DeqOption.builder().resource("OIVPTDQR")
                    .length(8).build();
            TaskControl.deq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0300_GO_MAIN() throws CicsException {
        // ("EXEC CICS START TRANSID('OIVP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIVP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPMAIN_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPINQR_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_INFO() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPINQR_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPINQR_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPINQR_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID ('OIIQ') COMMAREA (WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPINQR_DFHCOMMAREADto dfhcommareaDto = new OIVPINQR_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIIQ")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPINQR_DFHCOMMAREADto dfhcommareaDto = new OIVPINQR_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM03') MAPSET('OIVPM03') FROM(OIVPM03O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPINQR_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM03");
            outputDto.getScreenDto().setMapSetName("OIVPM03");
            try {
                OIVPM03_OIVPM03_data oivpm03_oivpm03_data = new OIVPM03_OIVPM03_data();
                OIVPM03_OIVPM03_meta oivpm03_oivpm03_meta = new OIVPM03_OIVPM03_meta();
                OIVPINQR_OIVPM03OToOIVPM03_OIVPM03_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM03O(), oivpm03_oivpm03_data);
                OIVPINQR_OIVPM03OToOIVPM03_OIVPM03_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM03O(), oivpm03_oivpm03_meta);
                outputDto.getScreenDto().setOIVPM03_OIVPM03_data(
                        oivpm03_oivpm03_data);
                outputDto.getScreenDto().setOIVPM03_OIVPM03_meta(
                        oivpm03_oivpm03_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM03') MAPSET('OIVPM03') FROM(OIVPM03O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPINQR_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM03");
            outputDto.getScreenDto().setMapSetName("OIVPM03");
            try {
                OIVPM03_OIVPM03_data oivpm03_oivpm03_data = new OIVPM03_OIVPM03_data();
                OIVPM03_OIVPM03_meta oivpm03_oivpm03_meta = new OIVPM03_OIVPM03_meta();
                OIVPINQR_OIVPM03OToOIVPM03_OIVPM03_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM03O(), oivpm03_oivpm03_data);
                OIVPINQR_OIVPM03OToOIVPM03_OIVPM03_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM03O(), oivpm03_oivpm03_meta);
                outputDto.getScreenDto().setOIVPM03_OIVPM03_data(
                        oivpm03_oivpm03_data);
                outputDto.getScreenDto().setOIVPM03_OIVPM03_meta(
                        oivpm03_oivpm03_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        container.setOIVPM03I(OIVPINQR_OIVPM03I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY ENTERED");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM (\"ERROR\") ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("ERROR");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPINQR_DFHCOMMAREADto dfhcommareaDto = new OIVPINQR_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
